unit Seriell;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Menus;

type
  TSeriellForm = class(TForm)
    Panel1: TPanel;
    Edit: TEdit;
    BitBtn1: TBitBtn;
    Memo: TRichEdit;
    BitBtn2: TBitBtn;
    PopupMenu: TPopupMenu;
    N01: TMenuItem;
    N11: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N61: TMenuItem;
    N71: TMenuItem;
    N81: TMenuItem;
    N91: TMenuItem;
    N101: TMenuItem;
    N111: TMenuItem;
    N121: TMenuItem;
    N13Enter1: TMenuItem;
    N141: TMenuItem;
    N151: TMenuItem;
    N161: TMenuItem;
    N171: TMenuItem;
    N181: TMenuItem;
    N191: TMenuItem;
    N201: TMenuItem;
    N211: TMenuItem;
    N221: TMenuItem;
    N231: TMenuItem;
    N241: TMenuItem;
    N261: TMenuItem;
    N262: TMenuItem;
    N271: TMenuItem;
    N281: TMenuItem;
    N291: TMenuItem;
    N301: TMenuItem;
    N311: TMenuItem;
    PopupMenu1: TPopupMenu;
    Lschen1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure SonderzeichenWahl(Sender: TObject);
    procedure Lschen1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    LastAdd : Char;
  public
    { Public-Deklarationen }
    Procedure AddChar(C : Char);
  end;

var
  SeriellForm: TSeriellForm = nil;

implementation

uses MainUnit;

{$R *.DFM}

procedure TSeriellForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SeriellForm:=nil;
  Action:=caFree;
end;

procedure TSeriellForm.BitBtn1Click(Sender: TObject);
begin
  If Memo.Lines[Memo.Lines.Count-1]='' then
    Memo.Lines[Memo.Lines.Count-1]:=Edit.Text
  else
    Memo.Lines.Add(Edit.Text);
  Memo.Lines.Add('');
  MainForm.System8051.ALU.SeriellInBuffer:=MainForm.System8051.ALU.SeriellInBuffer+Edit.Text;
  Edit.Text:='';
end;

procedure TSeriellForm.FormShow(Sender: TObject);
begin
  Memo.Lines.Add('');
end;

procedure TSeriellForm.AddChar(C: Char);
begin
  If (C=#13) or (C=#10) then begin
    If ((LastAdd<>#10) and (LastAdd<>#13)) or (LastAdd=C) then Memo.Lines.Add('');
  end else
  Memo.Lines[Memo.Lines.Count-1]:=Memo.Lines[Memo.Lines.Count-1]+C;
  Memo.SelStart:=MaxInt; Memo.SelStart:=Memo.SelStart-3;
  Memo.SelLength:=1;
  Memo.SelAttributes.Style:=[fsBold];
  Memo.SelStart:=MaxInt;
  LastAdd:=C;
end;

procedure TSeriellForm.EditKeyPress(Sender: TObject; var Key: Char);
begin
  If Key=#13 then begin BitBtn1Click(Sender); Key:=#0; end;
end;

procedure TSeriellForm.FormCreate(Sender: TObject);
begin
  If MainForm.WindowStyle.ItemIndex>=0 then
    BoundsRect:=MainForm.SetupData.WindowSetup[MainForm.WindowStyle.ItemIndex].SeriellWnd;
end;

procedure TSeriellForm.BitBtn2Click(Sender: TObject);
Var P : TPoint;
begin
  P:=ClientToScreen(Point(BitBtn2.Left,BitBtn2.Top));
  PopupMenu.Popup(P.x,P.y);
end;

procedure TSeriellForm.SonderzeichenWahl(Sender: TObject);
Var S : String;
begin
  S:=Trim((Sender as TMenuitem).Caption);
  If Pos(' ',S)<>0 then S:=Trim(Copy(S,1,Pos(' ',S)-1));
  MainForm.System8051.ALU.SeriellInBuffer:=MainForm.System8051.ALU.SeriellInBuffer+Char(StrToInt(S));
end;

procedure TSeriellForm.Lschen1Click(Sender: TObject);
begin
  Memo.Clear;
end;

end.
