unit AnalogDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Spin, Buttons;

type
  TAnalogForm = class(TForm)
    TrackBar1: TTrackBar;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    Label2: TLabel;
    TrackBar2: TTrackBar;
    SpinEdit2: TSpinEdit;
    Label3: TLabel;
    TrackBar3: TTrackBar;
    SpinEdit3: TSpinEdit;
    Label4: TLabel;
    TrackBar4: TTrackBar;
    SpinEdit4: TSpinEdit;
    Label5: TLabel;
    TrackBar5: TTrackBar;
    SpinEdit5: TSpinEdit;
    Label6: TLabel;
    TrackBar6: TTrackBar;
    SpinEdit6: TSpinEdit;
    Label7: TLabel;
    TrackBar7: TTrackBar;
    SpinEdit7: TSpinEdit;
    Label8: TLabel;
    TrackBar8: TTrackBar;
    SpinEdit8: TSpinEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure TrackBarChange(Sender: TObject);
    procedure SpinEditChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  AnalogForm: TAnalogForm;

implementation

uses MainUnit;

{$R *.DFM}

procedure TAnalogForm.TrackBarChange(Sender: TObject);
Var I,X : Integer;
begin
  I:=(Sender as TTrackBar).Position;
  For X:=0 to ControlCount do
    If (Controls[X] is TSpinEdit) and (TSpinEdit(Controls[X]).Tag=TTrackBar(Sender).Tag) then begin
      TSpinEdit(Controls[X]).Value:=I; break;
    end;
end;

procedure TAnalogForm.SpinEditChange(Sender: TObject);
Var I,X : Integer;
begin
  I:=(Sender as TSpinEdit).Value;
  For X:=0 to ControlCount do
    If (Controls[X] is TTrackBar) and (TTrackBar(Controls[X]).Tag=TSpinEdit(Sender).Tag) then begin
      TTrackBar(Controls[X]).Position:=I; break;
    end;
end;

procedure TAnalogForm.BitBtn1Click(Sender: TObject);
Var X : Integer;
begin
  For X:=0 to 7 do
    MainForm.System8051.AnalogValue[X]:=(FindComponent('SpinEdit'+IntToStr(X+1)) as TSpinEdit).Value;
end;

procedure TAnalogForm.FormShow(Sender: TObject);
Var X : Integer;
begin
  For X:=0 to 7 do
    (FindComponent('SpinEdit'+IntToStr(X+1)) as TSpinEdit).Value:=MainForm.System8051.AnalogValue[X];
end;

end.
